﻿using System;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;

namespace TrisUdp
{
    public partial class FormGioco : Form
    {
      private const int LOCALPORT = 6000;
        private Boolean PartitaInCorso = false;
        private Button[] btnCampo = new Button[9];
        private string ipAvversario;
        private int portaAvversario;
        private string username;
        Socket udpSocket;     
        EndPoint ep;          
        byte[] abytRx = new byte[1024];  
        byte[] abytTx = new byte[1024];  
        Boolean toccaMe = false;
        int numMosse = 0;


        public FormGioco()
        {
            InitializeComponent();
            btnCampo[0] = btn0;
            btnCampo[1] = btn1;
            btnCampo[2] = btn2;
            btnCampo[3] = btn3;
            btnCampo[4] = btn4;
            btnCampo[5] = btn5;
            btnCampo[6] = btn6;
            btnCampo[7] = btn7;
            btnCampo[8] = btn8;

            this.username = "C# Itis";
            txtIo.Text = this.username;
            txtPortaLocale.Text = LOCALPORT.ToString();

            IPEndPoint ipEndPoint;
            udpSocket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            ipEndPoint = new IPEndPoint(IPAddress.Any, LOCALPORT);
            udpSocket.Bind(ipEndPoint);
            ep = (EndPoint)ipEndPoint;
            udpSocket.BeginReceiveFrom(abytRx, 0, abytRx.Length, SocketFlags.None, ref ep, new AsyncCallback(OnReceive), ep);
        }


        private void btnConnessione_Click(object sender, EventArgs e)
        {

            IPEndPoint ipEndPoint;
            IPAddress ipAddress;

            ipAddress = IPAddress.Parse(tbIp.Text);
            ipEndPoint = new IPEndPoint(ipAddress, Convert.ToInt32(tbPorta.Text));
            ep = (EndPoint)ipEndPoint;
            try
            {
                abytTx = Encoding.UTF8.GetBytes((char)1 + username + (char)0);
                udpSocket.BeginSendTo(abytTx, 0, username.Length + 1, SocketFlags.None, ep, new AsyncCallback(OnSend), null);
            }
            catch (Exception)
            {
                MessageBox.Show("Problema: non è possibile spedire", "udpP2P", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private delegate void del_OnReceive(IAsyncResult ar);
        private void OnReceive(IAsyncResult ar)
        {
            if (InvokeRequired)
            {
                BeginInvoke(new del_OnReceive(OnReceive), ar);
                return;
            }

            try
            {
                IPEndPoint ipepAltro = new IPEndPoint(IPAddress.Any, 0);
                ep = (EndPoint)ipepAltro;
                string strReceived;
                char[] opCode;
                string str;
                int idx;
                DialogResult risposta;

                udpSocket.EndReceiveFrom(ar, ref ep);
                str = ep.ToString();
                string[] astr = str.Split(':');
                ipAvversario = astr[0];
                portaAvversario = Convert.ToInt32(astr[1]);
                opCode = Encoding.UTF8.GetChars(abytRx, 0, 1);
                strReceived = Encoding.UTF8.GetString(abytRx);  // trasformo in stringa i dati ricevuti
                strReceived = strReceived.Substring(1); // tolgo l'opCode

                switch (opCode[0])
                {
                    case (char)1:

                        idx = strReceived.IndexOf((char)0);
                        if (idx > -1)
                        {
                            str = strReceived.Substring(0, strReceived.IndexOf((char)0));
                        }
                        else
                        {
                            str = strReceived;
                        }

                        IPEndPoint ipEndPoint;
                        IPAddress ipAddress;

                        ipAddress = IPAddress.Parse(ipAvversario);
                        ipEndPoint = new IPEndPoint(ipAddress, portaAvversario);
                        ep = (EndPoint)ipEndPoint;

                        if (PartitaInCorso == false)
                        {
                            risposta = MessageBox.Show("Vuoi giocare con " + str + " ?", "Inizio partita", MessageBoxButtons.YesNo);
                            if (risposta == System.Windows.Forms.DialogResult.Yes)
                            {
                                try
                                {
                                    abytTx = Encoding.UTF8.GetBytes("" + (char)4 + username + (char)0);
                                    udpSocket.BeginSendTo(abytTx, 0, abytTx.Length, SocketFlags.None, ep, new AsyncCallback(OnSend), null);
                                    btnConnessione.Enabled = false;
                                }
                                catch (Exception)
                                {
                                    MessageBox.Show("Problema: non è possibile spedire", "udpP2P", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                }
                                txtAvversario.Text = str;
                                PartitaInCorso = true;
                                numMosse = 0;
                            }
                            else
                            {
                                try
                                {
                                    abytTx = Encoding.UTF8.GetBytes("" + (char)5);
                                    udpSocket.BeginSendTo(abytTx, 0, abytTx.Length, SocketFlags.None, ep, new AsyncCallback(OnSend), null);
                                }
                                catch (Exception)
                                {
                                    MessageBox.Show("Problema: non è possibile spedire", "udpP2P", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                }
                            }
                        }
                        else
                        {
                            try
                            {
                                abytTx = Encoding.UTF8.GetBytes("" + (char)5);
                                udpSocket.BeginSendTo(abytTx, 0, abytTx.Length, SocketFlags.None, ep, new AsyncCallback(OnSend), null);
                            }
                            catch (Exception)
                            {
                                MessageBox.Show("Problema: non è possibile spedire", "udpP2P", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            }
                        }
                        break;

                    case (char)2:
                        string tmp = strReceived.Substring(0, 1);
                        int indice = Convert.ToInt32(Convert.ToChar(tmp));
                        btnCampo[indice].Text = "O";
                        toccaMe = true;
                        numMosse++;

                        if (numMosse >= 5)
                        {
                            if (((btnCampo[0].Text.Equals(btnCampo[1].Text) && btnCampo[0].Text.Equals(btnCampo[2].Text)) ||
                                (btnCampo[3].Text.Equals(btnCampo[4].Text) && btnCampo[3].Text.Equals(btnCampo[5].Text)) ||
                                (btnCampo[6].Text.Equals(btnCampo[7].Text) && btnCampo[6].Text.Equals(btnCampo[8].Text)) ||
                                (btnCampo[0].Text.Equals(btnCampo[3].Text) && btnCampo[0].Text.Equals(btnCampo[6].Text)) ||
                                (btnCampo[1].Text.Equals(btnCampo[4].Text) && btnCampo[1].Text.Equals(btnCampo[7].Text)) ||
                                (btnCampo[2].Text.Equals(btnCampo[5].Text) && btnCampo[2].Text.Equals(btnCampo[8].Text)) ||
                                (btnCampo[0].Text.Equals(btnCampo[4].Text) && btnCampo[0].Text.Equals(btnCampo[8].Text)) ||
                                (btnCampo[2].Text.Equals(btnCampo[4].Text) && btnCampo[2].Text.Equals(btnCampo[6].Text))) &&
                                (((!btnCampo[0].Text.Equals("") && !btnCampo[1].Text.Equals("")) ||
                                (!btnCampo[3].Text.Equals("") && !btnCampo[4].Text.Equals("")) ||
                                (!btnCampo[6].Text.Equals("") && !btnCampo[7].Text.Equals("")) ||
                                (!btnCampo[0].Text.Equals("") && !btnCampo[3].Text.Equals("")) ||
                                (!btnCampo[1].Text.Equals("") && !btnCampo[4].Text.Equals("")) ||
                                (!btnCampo[2].Text.Equals("") && !btnCampo[5].Text.Equals("")) ||
                                (!btnCampo[0].Text.Equals("") && !btnCampo[4].Text.Equals("")) ||
                                (!btnCampo[2].Text.Equals("") && !btnCampo[4].Text.Equals("")))))
                            {
                                MessageBox.Show("HA VINTO " + txtAvversario.Text);
                                PartitaInCorso = false;
                                btnNuova.Enabled = true;
                            }
                            else
                                if (numMosse == 9)
                                {
                                    MessageBox.Show("Parità!");
                                    PartitaInCorso = false;
                                    btnNuova.Enabled = true;
                                }

                        }

                        break;

                    case (char)3:

                        risposta = MessageBox.Show("Vuoi rigiocare ?", "Nuova partita", MessageBoxButtons.YesNo);

                        if (risposta == System.Windows.Forms.DialogResult.Yes)
                        {
                            for (int i = 0; i < btnCampo.Length; i++)
                            {
                                btnCampo[i].Text = "";
                            }
                            toccaMe = true;
                            PartitaInCorso = true;
                            numMosse = 0;
                            btnNuova.Enabled = false;
                        }
                        else
                        {
                            ipAddress = IPAddress.Parse(ipAvversario);
                            ipEndPoint = new IPEndPoint(ipAddress, portaAvversario);
                            ep = (EndPoint)ipEndPoint;
                            abytTx = Encoding.UTF8.GetBytes("" + (char)5);
                            udpSocket.BeginSendTo(abytTx, 0, abytTx.Length, SocketFlags.None, ep, new AsyncCallback(OnSend), null);
                            PartitaInCorso = false;
                            numMosse = 0;
                        }
                        break;

                    case (char)4:

                        idx = strReceived.IndexOf((char)0);
                        if (idx > -1)
                        {
                            str = strReceived.Substring(0, strReceived.IndexOf((char)0));
                        }
                        else
                        {
                            str = strReceived;
                        }
                        txtAvversario.Text = str;
                        PartitaInCorso = true;
                        toccaMe = true;
                        break;

                    case (char)5:

                        if (!PartitaInCorso)
                            MessageBox.Show(ipAvversario + " Ha rifiutato la tua richiesta, l'utente non ha voglia di giocare o è già impegnato in un altra partita...");
                        else
                        {
                            PartitaInCorso = false;
                        }
                        break;
                }
                abytRx = new byte[abytRx.Length];
                udpSocket.BeginReceiveFrom(abytRx, 0, abytRx.Length, SocketFlags.None, ref ep, new AsyncCallback(OnReceive), ep);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Errore: " + ex.Message, "udpP2P", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    
        private delegate void del_OnSend(IAsyncResult ar);
        private void OnSend(IAsyncResult ar)
        {
            if (InvokeRequired)
            {
                BeginInvoke(new del_OnSend(OnSend), ar);
                return;
            }

            try
            {
                udpSocket.EndSend(ar);
            }
            catch (ObjectDisposedException)
            {
                MessageBox.Show("Errore: socket nullo", "udpP2P", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Errore: " + ex.Message, "udpP2P", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btn_Click(object sender, EventArgs e)
        {
            if (PartitaInCorso)
            {
                if (toccaMe)
                {
                    object tagButton = ((Button)sender).Tag;
                    int mossa = Convert.ToInt32(tagButton);
                    
                    if (((Button)sender).Text.Equals(""))
                    {
                        ((Button)sender).Text = "X";

                        IPEndPoint ipEndPoint;
                        IPAddress ipAddress;

                        ipAddress = IPAddress.Parse(ipAvversario);
                        ipEndPoint = new IPEndPoint(ipAddress, portaAvversario);
                        ep = (EndPoint)ipEndPoint;
                        abytTx = Encoding.UTF8.GetBytes("" + (char)2 + (char)mossa);
                        udpSocket.BeginSendTo(abytTx, 0, abytTx.Length, SocketFlags.None, ep, new AsyncCallback(OnSend), null);
                        toccaMe = false;
                        numMosse++;
                        if (numMosse >= 5)
                        {
                            if (((btnCampo[0].Text.Equals(btnCampo[1].Text) && btnCampo[0].Text.Equals(btnCampo[2].Text)) ||
                                (btnCampo[3].Text.Equals(btnCampo[4].Text) && btnCampo[3].Text.Equals(btnCampo[5].Text)) ||
                                (btnCampo[6].Text.Equals(btnCampo[7].Text) && btnCampo[6].Text.Equals(btnCampo[8].Text)) ||
                                (btnCampo[0].Text.Equals(btnCampo[3].Text) && btnCampo[0].Text.Equals(btnCampo[6].Text)) ||
                                (btnCampo[1].Text.Equals(btnCampo[4].Text) && btnCampo[1].Text.Equals(btnCampo[7].Text)) ||
                                (btnCampo[2].Text.Equals(btnCampo[5].Text) && btnCampo[2].Text.Equals(btnCampo[8].Text)) ||
                                (btnCampo[0].Text.Equals(btnCampo[4].Text) && btnCampo[0].Text.Equals(btnCampo[8].Text)) ||
                                (btnCampo[2].Text.Equals(btnCampo[4].Text) && btnCampo[2].Text.Equals(btnCampo[6].Text))) &&
                                (((!btnCampo[0].Text.Equals("") && !btnCampo[2].Text.Equals("")) ||
                                (!btnCampo[3].Text.Equals("") && !btnCampo[5].Text.Equals("")) ||
                                (!btnCampo[6].Text.Equals("") && !btnCampo[8].Text.Equals("")) ||
                                (!btnCampo[0].Text.Equals("") && !btnCampo[6].Text.Equals("")) ||
                                (!btnCampo[1].Text.Equals("") && !btnCampo[7].Text.Equals("")) ||
                                (!btnCampo[2].Text.Equals("") && !btnCampo[8].Text.Equals("")) ||
                                (!btnCampo[0].Text.Equals("") && !btnCampo[8].Text.Equals("")) ||
                                (!btnCampo[2].Text.Equals("") && !btnCampo[6].Text.Equals("")))))
                            {
                                MessageBox.Show("HAI VINTO!");
                                PartitaInCorso = false;
                                btnNuova.Enabled = true;
                            }
                            else
                                if(numMosse == 9)
                                {
                                    MessageBox.Show("Parità!");
                                    PartitaInCorso = false;
                                    btnNuova.Enabled = true;
                                }
                        }
                       
                    }
                    else
                    {
                        MessageBox.Show("Attenzione campo già utilizzato!");
                    }
                }

            }

        }

        private void btnNuova_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < btnCampo.Length; i++)
            {
                btnCampo[i].Text = "";
            }

            IPEndPoint ipEndPoint;
            IPAddress ipAddress;

            ipAddress = IPAddress.Parse(ipAvversario);
            ipEndPoint = new IPEndPoint(ipAddress, portaAvversario);
            ep = (EndPoint)ipEndPoint;
            abytTx = Encoding.UTF8.GetBytes("" + (char)3);
            udpSocket.BeginSendTo(abytTx, 0, abytTx.Length, SocketFlags.None, ep, new AsyncCallback(OnSend), null);
            toccaMe = false;
            PartitaInCorso = true;
            numMosse = 0;
        }
    }
}