import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Panel;
import java.awt.Toolkit;


public class Cella extends Panel {
	private static final long serialVersionUID = 7692528792460871439L;
	private static Image cell;
	private static Image x_cell;
	private static Image o_cell;
	
	public static final int VOID = 0;
	public static final int X    = 1;
	public static final int O    = 2;
	
	private Image img;
	private int   status = VOID;
	
	public static void init() {
		cell = Toolkit.getDefaultToolkit().createImage("cell.png");
		x_cell = Toolkit.getDefaultToolkit().createImage("x.png");
		o_cell = Toolkit.getDefaultToolkit().createImage("o.png");
	}
	
	public Cella() {
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(cell, 0);
		mt.addImage(x_cell, 1);
		mt.addImage(o_cell, 2);
		try{ 
        	mt.waitForID(0); 
		} 
		catch (InterruptedException err){
		}
		try{ 
        	mt.waitForID(1);
		} 
		catch (InterruptedException err){
		}
		try{ 
        	mt.waitForID(2);
		} 
		catch (InterruptedException err){
		}
		reset();
	}
	
	public boolean putX() {
		if (status != VOID) return false;
		img = x_cell;
		status = X;
		this.setName("X");
		repaint();
		return true;
	}
	
	public boolean putO() {
		if (status != VOID) return false;
		img = o_cell;
		status = O;
		this.setName("O");
		repaint();
		return true;
	}
	
	public void reset() {
		img = cell;
		status = VOID;
		this.setName("");
		repaint();
	}
	
	public int getStatus() {
		return status;
	}
	
	public boolean setStatus(int s) {
		if (s == VOID) {
			reset();
			return true;
		}
		if (s == X) return putX();
		if (s == O) return putO();
		return false;
	}
	
	public void paint(Graphics g) {
		g.drawImage(img, 0, 0, null);
	}
}
